BigIdeal Class Reference

`#include <BigIdeal.h>`

## Public Member Functions

| BigIdeal ()
| BigIdeal (const VarNames &names)
void | insert (const Ideal &ideal)
void | insert (const Ideal &ideal, const TermTranslator &translator)
void | insert (const SquareFreeIdeal &ideal)
void | insert (const vector< mpz_class > &term)
void | renameVars (const VarNames &names)
void | newLastTerm ()
void | reserve (size_t capacity)
mpz_class & | getLastTermExponentRef (size_t var)
vector< mpz_class > & | getLastTermRef ()
const vector< mpz_class > & | getTerm (size_t term) const
void | getLcm (vector< mpz_class > &lcm) const
const mpz_class & | getExponent (size_t term, size_t var) const
mpz_class & | getExponent (size_t term, size_t var)
void | setExponent (size_t term, size_t var, const mpz_class &exp)
bool | operator== (const BigIdeal &b) const
vector< mpz_class > & | operator[] (size_t index)
const vector< mpz_class > & | operator[] (size_t index) const
void | projectVar (size_t var)
bool | operator< (const BigIdeal &ideal) const
bool | empty () const
bool | containsIdentity () const
bool | contains (const vector< mpz_class > &term) const
void | clear ()
size_t | getGeneratorCount () const
size_t | getVarCount () const
void | clearAndSetNames (const VarNames &names)
bool | addVarToClearedIdeal (const char *var)
void | eraseVar (size_t var)
const VarNames & | getNames () const
void | deform ()
void | takeRadical ()
void | sortGeneratorsUnique ()
void | sortGenerators ()
void | sortVariables ()
void | swap (BigIdeal &ideal)
void | print (FILE *file) const
void | print (ostream &out) const

## Static Public Member Functions

static bool | bigTermCompare (const vector< mpz_class > &a, const vector< mpz_class > &b)

## Private Attributes

vector< vector< mpz_class > > | _terms
VarNames | _names

## Detailed Description

Definition at line 27 of file BigIdeal.h.

## Constructor & Destructor Documentation

## BigIdeal() [1/2]

BigIdeal::BigIdeal | ( |  | ) |

Definition at line 53 of file BigIdeal.cpp.

## BigIdeal() [2/2]

BigIdeal::BigIdeal | ( | const VarNames & | names | ) |

Definition at line 56 of file BigIdeal.cpp.

## Member Function Documentation

## addVarToClearedIdeal()

bool BigIdeal::addVarToClearedIdeal | ( | const char * | var | ) |

Definition at line 227 of file BigIdeal.cpp.

## bigTermCompare()

bool BigIdeal::bigTermCompare | ( | const vector< mpz_class > & | a,
|  | const vector< mpz_class > & | b )

static

Definition at line 349 of file BigIdeal.cpp.

## clear()

void BigIdeal::clear | ( |  | ) |

Definition at line 218 of file BigIdeal.cpp.

## clearAndSetNames()

void BigIdeal::clearAndSetNames | ( | const VarNames & | names | ) |

Definition at line 222 of file BigIdeal.cpp.

## contains()

bool BigIdeal::contains | ( | const vector< mpz_class > & | term | ) | const

Definition at line 207 of file BigIdeal.cpp.

## containsIdentity()

bool BigIdeal::containsIdentity | ( |  | ) | const

Definition at line 196 of file BigIdeal.cpp.

## deform()

void BigIdeal::deform | ( |  | ) |

Definition at line 257 of file BigIdeal.cpp.

## empty()

bool BigIdeal::empty | ( |  | ) | const

Definition at line 192 of file BigIdeal.cpp.

## eraseVar()

void BigIdeal::eraseVar | ( | size_t | var | ) |

Definition at line 233 of file BigIdeal.cpp.

## getExponent() [1/2]

mpz_class & BigIdeal::getExponent | ( | size_t | term,
|  | size_t | var )

Definition at line 335 of file BigIdeal.cpp.

## getExponent() [2/2]

const mpz_class & BigIdeal::getExponent | ( | size_t | term,
|  | size_t | var ) const

Definition at line 328 of file BigIdeal.cpp.

## getGeneratorCount()

size_t BigIdeal::getGeneratorCount | ( |  | ) | const

inline

Definition at line 144 of file BigIdeal.h.

## getLastTermExponentRef()

mpz_class & BigIdeal::getLastTermExponentRef | ( | size_t | var | ) |

inline

Definition at line 126 of file BigIdeal.h.

## getLastTermRef()

vector< mpz_class > & BigIdeal::getLastTermRef | ( |  | ) |

inline

Definition at line 133 of file BigIdeal.h.

## getLcm()

void BigIdeal::getLcm | ( | vector< mpz_class > & | lcm | ) | const

Definition at line 143 of file BigIdeal.cpp.

## getNames()

const VarNames & BigIdeal::getNames | ( |  | ) | const

Definition at line 253 of file BigIdeal.cpp.

## getTerm()

const vector< mpz_class > & BigIdeal::getTerm | ( | size_t | term | ) | const

inline

Definition at line 139 of file BigIdeal.h.

## getVarCount()

size_t BigIdeal::getVarCount | ( |  | ) | const

inline

Definition at line 148 of file BigIdeal.h.

## insert() [1/4]

void BigIdeal::insert | ( | const Ideal & | ideal | ) |

Definition at line 60 of file BigIdeal.cpp.

## insert() [2/4]

void BigIdeal::insert | ( | const Ideal & | ideal,
|  | const TermTranslator & | translator )

Definition at line 71 of file BigIdeal.cpp.

## insert() [3/4]

void BigIdeal::insert | ( | const SquareFreeIdeal & | ideal | ) |

Definition at line 83 of file BigIdeal.cpp.

## insert() [4/4]

void BigIdeal::insert | ( | const vector< mpz_class > & | term | ) |

Definition at line 94 of file BigIdeal.cpp.

## newLastTerm()

void BigIdeal::newLastTerm | ( |  | ) |

Definition at line 104 of file BigIdeal.cpp.

## operator<()

bool BigIdeal::operator< | ( | const BigIdeal & | ideal | ) | const

Definition at line 166 of file BigIdeal.cpp.

## operator==()

bool BigIdeal::operator== | ( | const BigIdeal & | b | ) | const

Definition at line 154 of file BigIdeal.cpp.

## operator[]() [1/2]

vector< mpz_class > & BigIdeal::operator[] | ( | size_t | index | ) |

inline

Definition at line 116 of file BigIdeal.h.

## operator[]() [2/2]

const vector< mpz_class > & BigIdeal::operator[] | ( | size_t | index | ) | const

inline

Definition at line 121 of file BigIdeal.h.

## print() [1/2]

void BigIdeal::print | ( | FILE * | file | ) | const

Definition at line 310 of file BigIdeal.cpp.

## print() [2/2]

void BigIdeal::print | ( | ostream & | out | ) | const

Definition at line 316 of file BigIdeal.cpp.

## projectVar()

void BigIdeal::projectVar | ( | size_t | var | ) |

Definition at line 158 of file BigIdeal.cpp.

## renameVars()

void BigIdeal::renameVars | ( | const VarNames & | names | ) |

Definition at line 99 of file BigIdeal.cpp.

## reserve()

void BigIdeal::reserve | ( | size_t | capacity | ) |

Definition at line 112 of file BigIdeal.cpp.

## setExponent()

void BigIdeal::setExponent | ( | size_t | term,
|  | size_t | var,
|  | const mpz_class & | exp )

Definition at line 342 of file BigIdeal.cpp.

## sortGenerators()

void BigIdeal::sortGenerators | ( |  | ) |

Definition at line 280 of file BigIdeal.cpp.

## sortGeneratorsUnique()

void BigIdeal::sortGeneratorsUnique | ( |  | ) |

Definition at line 273 of file BigIdeal.cpp.

## sortVariables()

void BigIdeal::sortVariables | ( |  | ) |

Definition at line 298 of file BigIdeal.cpp.

## swap()

void BigIdeal::swap | ( | BigIdeal & | ideal | ) |

Definition at line 305 of file BigIdeal.cpp.

## takeRadical()

void BigIdeal::takeRadical | ( |  | ) |

Definition at line 264 of file BigIdeal.cpp.

## Member Data Documentation

## _names

VarNames BigIdeal::_names

private

Definition at line 108 of file BigIdeal.h.

## _terms

vector<vector<mpz_class> > BigIdeal::_terms

private

Definition at line 107 of file BigIdeal.h.

The documentation for this class was generated from the following files:

- src/BigIdeal.h
- src/BigIdeal.cpp